﻿
----------------------------------------
-- Index
----------------------------------------
-- Variables
-- Getters
-- Frames
-- Background Frame
-- Small Frames
-- Functions
-- Options Frame
-- CheckButtons
-- Info Frame
-- Updates
-- Event Frames
-- Slash Commands
----------------------------------------


----------------------------------------
-- Variables
----------------------------------------

local _
local FrameTable = {}
--local firstRun = true
local initialTable = {}
local runCount = 0
local debugMode = false -- disable debug options (personal use when fixing the addon)
local versionNr = "5.3a"
local versionDate = "May 23 2013"

----------------------------------------
-- Getters
----------------------------------------

function GetAccHKills()

-- Temp way of tracking account wide Hk. capped at 250k
local _, _, _, HKills, _, _, _, _, _, _ = GetAchievementCriteriaInfo(5363, 1)

--local HKills, _ = GetPVPLifetimeStats()
   return HKills
end

function GetHKills()

   local HKills, _ = GetPVPLifetimeStats()
   return HKills
end

function GetHonor()
   local _, CurrInfo, _, _, _, _ = GetCurrencyInfo(392)
   return CurrInfo
end

function GetConquest()
   local _, CurrInfo, _, _, _, _ = GetCurrencyInfo(390)
   return CurrInfo
end

function GetTB()
   local _, CurrInfo, _, _, _, _ = GetCurrencyInfo(391)
   return CurrInfo
end

----------------------------------------
-- Frames
----------------------------------------

----------------------------------------
-- Background Frame
----------------------------------------

local BGStatFrame = CreateFrame("frame", "BGStatFrame", UIParent)
function MainFrameBG()
if BGStatFrame:IsMouseEnabled() then
BGStatFrame:SetBackdrop({
bgFile = [[Interface\COMMON\ShadowOverlay-Right]],
      edgeFile = [[Interface/DialogFrame/UI-DialogBox-Border]],
	  tileSize = 16, edgeSize = 16,
      insets = { left = 3, right = 3, top = 5, bottom = 3 }
	  })
else
BGStatFrame:SetBackdrop({
      bgFile = [[Interface\COMMON\ShadowOverlay-Right]],
	  edgeFile = nill,
      tileSize = 16, edgeSize = 16,
      insets = { left = 3, right = 3, top = 5, bottom = 3 }
	  })
	  end
	  end
	 MainFrameBG()
BGStatFrame:SetWidth(100)
BGStatFrame:SetHeight(300)
BGStatFrame:SetMovable(true)
BGStatFrame:SetPoint("Center", 200, 0)
BGStatFrame:RegisterForDrag("LeftButton")
BGStatFrame:SetScript("OnDragStart", BGStatFrame.StartMoving )
BGStatFrame:SetScript("OnDragStop", 
BGStatFrame.StopMovingOrSizing)
BGStatFrame:SetClampedToScreen(true)
BGStatFrame:Show()

------------------------------------------------------------------------------------------------------------------------

local Icon = CreateFrame("Frame", "Icon", BGStatFrame)
Icon:SetWidth(24)
Icon:SetHeight(24)
function FactionIcon()
   local EnglishFaction, localizedFaction = UnitFactionGroup("player")
   if EnglishFaction == "Horde" then
      Icon:SetBackdrop({
            bgFile = [[Interface\PVPFrame\PVP-Currency-Horde]],
            edgeFile = nil,
            tileSize = 32, edgeSize = 16,
      })
   else
      Icon:SetBackdrop({
            bgFile = [[Interface\PVPFrame\PVP-Currency-Alliance]],
            edgeFile = nil,
            tileSize = 32, edgeSize = 16,
      })
   end
end
FactionIcon()
Icon:SetPoint("topleft", BGStatFrame, "topleft", 0, -2)
Icon.text = Icon:CreateFontString(nil, nil, "QuestFont_Shadow_Small")
Icon.text:SetPoint("left", 25, 3)
Icon.text:SetText("BG Stats")
Icon:Show()

------------------------------------------------------------------------------------------------------------------------

local CloseButton = CreateFrame("Button", "CloseButton", BGStatFrame)
CloseButton:SetWidth(15)
CloseButton:SetHeight(15)
CloseButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Up")
CloseButton:SetHighlightTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Highlight")
CloseButton:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Down")
CloseButton:SetPoint("topright", BGStatFrame, "topright", 0, -2)
CloseButton:Show()
CloseButton:SetScript("OnClick",  function() 
      BGStatFrame:Hide() 
      IsShown = false
end)

------------------------------------------------------------------------------------------------------------------------

local ConfigButton = CreateFrame("Button", "ConfigButton", BGStatFrame)
ConfigButton:SetWidth(8)
ConfigButton:SetHeight(8)
ConfigButton:SetNormalTexture("Interface\\BUTTONS\\UI-GuildButton-PublicNote-Up")
ConfigButton:SetHighlightTexture("Interface\\BUTTONS\\UI-GuildButton-PublicNote-Up")
ConfigButton:SetPushedTexture("Interface\\BUTTONS\\UI-GuildButton-OfficerNote-Up")
ConfigButton:SetPoint("topright", BGStatFrame, "topright", -4, -15)
ConfigButton:Show()
ConfigButton:SetScript("OnClick",  function() 
	  if  BGS_OptionsFrame:IsShown() then
         BGS_OptionsFrame:Hide()
      else
         BGS_OptionsFrame:Show()
      end
end)

----------------------------------------
-- Small Frames
----------------------------------------
local BGS_HonorFrame = CreateFrame("frame", "BGS_HonorFrame", BGStatFrame)
BGS_HonorFrame.text = BGS_HonorFrame:CreateFontString(nil, nil, "GameFontNormal")
BGS_HonorFrame.text:SetPoint("left", 25, 0)
function UpdateHonorInfo()
   BGS_HonorFrame.text:SetText(GetHonor())
end
UpdateHonorInfo()
BGS_HonorFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, -25)
BGS_HonorFrame:SetWidth(BGStatFrame:GetWidth())
BGS_HonorFrame:SetHeight(20)
BGS_HonorFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local BGS_HonorFrameIcon = CreateFrame("frame", "BGS_HonorFrameIcon", BGS_HonorFrame)
function HonorIcon()
   local EnglishFaction, localizedFaction = UnitFactionGroup("player")
   if EnglishFaction == "Horde" then
      BGS_HonorFrameIcon:SetBackdrop({
            bgFile = [[Interface\PvPFrame\PVPCurrency-Honor-Horde]],
            edgeFile = nill,
            tile = true,
            tileSize = 17, edgeSize = 17,
            insets = { left = -1, right = -2, top = -2, bottom = -2 }
      })
   else
      BGS_HonorFrameIcon:SetBackdrop({
            bgFile = [[Interface\PvPFrame\PVPCurrency-Honor-Alliance]],
            edgeFile = nill,
            tile = true,
            tileSize = 17, edgeSize = 178,
            insets = { left = -1, right = -2, top = -2, bottom = -2 }
      })
   end
end
HonorIcon()
BGS_HonorFrameIcon:SetWidth(BGS_HonorFrame:GetHeight())
BGS_HonorFrameIcon:SetHeight(BGS_HonorFrame:GetHeight())
BGS_HonorFrameIcon:SetPoint("left", BGS_HonorFrame, "left", 0, 1)
BGS_HonorFrameIcon:Show()

------------------------------------------------------------------------------------------------------------------------

local BGS_ConquestFrame = CreateFrame("frame", "BGS_ConquestFrame", BGStatFrame)
BGS_ConquestFrame.text = BGS_ConquestFrame:CreateFontString(nil, nil, "GameFontNormal")
BGS_ConquestFrame.text:SetPoint("left", 25, 0)
function UpdateConquestInfo()
   BGS_ConquestFrame.text:SetText(GetConquest())
end
UpdateConquestInfo()
space = 0
if BGS_HonorFrame:IsShown() then
   space = BGS_HonorFrame:GetHeight()
end
BGS_ConquestFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, -25 - space)
BGS_ConquestFrame:SetWidth(BGStatFrame:GetWidth())
BGS_ConquestFrame:SetHeight(20)
BGS_ConquestFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local BGS_ConquestFrameIcon = CreateFrame("frame", "BGS_ConquestFrameIcon", BGS_ConquestFrame)
function ConquestIcon()
   local EnglishFaction, localizedFaction = UnitFactionGroup("player")
   if EnglishFaction == "Horde" then
      BGS_ConquestFrameIcon:SetBackdrop({
            bgFile = [[Interface\PvPFrame\PVPCurrency-Conquest-Horde]],
            edgeFile = nill,
            tile = false,
            tileSize = 22, edgeSize = 23,
            insets = { left = -1, right = -6, top = -2, bottom = -5 }
      })
   else
      BGS_ConquestFrameIcon:SetBackdrop({
            bgFile = [[Interface\PvPFrame\PVPCurrency-Conquest-Alliance]],
            edgeFile = nill,
            tile = false,
            tileSize = 22, edgeSize = 23,
            insets = { left = -1, right = -6, top = -2, bottom = -5 }
      })
   end
end
ConquestIcon()
BGS_ConquestFrameIcon:SetWidth(BGS_ConquestFrame:GetHeight())
BGS_ConquestFrameIcon:SetHeight(BGS_ConquestFrame:GetHeight())
BGS_ConquestFrameIcon:SetPoint("left", BGS_ConquestFrame, "left", 0, 1)
BGS_ConquestFrameIcon:Show()

------------------------------------------------------------------------------------------------------------------------

local BGS_KillsFrame = CreateFrame("frame", "BGS_KillsFrame", BGStatFrame)
BGS_KillsFrame.text = BGS_KillsFrame:CreateFontString(nil, nil, "GameFontNormal")
BGS_KillsFrame.text:SetPoint("left", 25, 0)
function UpdateKillsInfo()
   BGS_KillsFrame.text:SetText(GetHKills())
end
space = 0
if BGS_HonorFrame:IsShown() then
   space = space + BGS_HonorFrame:GetHeight()
end
if BGS_ConquestFrame:IsShown() then
   space = space + BGS_ConquestFrame:GetHeight()
end
BGS_KillsFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, -25 - space)
BGS_KillsFrame:SetWidth(BGStatFrame:GetWidth())
BGS_KillsFrame:SetHeight(20)
BGS_KillsFrame:Hide()
BGS_KillsFrame:SetScript("OnShow", UpdateKillsInfo)

local BGS_KillsFrameIcon = CreateFrame("frame", "BGS_KillsFrameIcon", BGS_KillsFrame)
BGS_KillsFrameIcon:SetBackdrop({
      
	  --bgFile = [[Interface\ICONS\INV_Misc_GroupLooking]],
      bgFile = [[Interface\TARGETINGFRAME\UI-TargetingFrame-Skull]],
      edgeFile = nill,
      tile = false,
      tileSize = 20 , edgeSize = 20 ,
      insets = { left = 0, right = 0, top = 0, bottom = 1 }
})
BGS_KillsFrameIcon:SetWidth(BGS_KillsFrame:GetHeight())
BGS_KillsFrameIcon:SetHeight(BGS_KillsFrame:GetHeight())
BGS_KillsFrameIcon:SetPoint("left", BGS_KillsFrame, "left", 4, -1)
BGS_KillsFrameIcon:Show()

------------------------------------------------------------------------------------------------------------------------

local AccBGS_KillsFrame = CreateFrame("frame", "AccBGS_KillsFrame", BGStatFrame)
AccBGS_KillsFrame.text = AccBGS_KillsFrame:CreateFontString(nil, nil, "GameFontNormal")
AccBGS_KillsFrame.text:SetPoint("left", 25, 0)
function UpdateAccKillsInfo()
   AccBGS_KillsFrame.text:SetText(GetAccHKills())
end
space = 0
if BGS_HonorFrame:IsShown() then
   space = space + BGS_HonorFrame:GetHeight()
end
if BGS_ConquestFrame:IsShown() then
   space = space + BGS_ConquestFrame:GetHeight()
end
AccBGS_KillsFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, -25 - space)
AccBGS_KillsFrame:SetWidth(BGStatFrame:GetWidth())
AccBGS_KillsFrame:SetHeight(20)
AccBGS_KillsFrame:Hide()
AccBGS_KillsFrame:SetScript("OnShow", UpdateAccKillsInfo)

------------------------------------------------------------------------------------------------------------------------

local AccBGS_KillsFrameIcon = CreateFrame("frame", "AccBGS_KillsFrameIcon", AccBGS_KillsFrame)
AccBGS_KillsFrameIcon:SetBackdrop({
      bgFile = [[Interface/WorldStateFrame/SkullBones]],
         edgeFile = nill,
         tile = false,
         tileSize = 20 , edgeSize = 20  ,
         insets = { left = 0, right = -20, top = 0 , bottom = -20}
})
AccBGS_KillsFrameIcon:SetWidth(AccBGS_KillsFrame:GetHeight())
AccBGS_KillsFrameIcon:SetHeight(AccBGS_KillsFrame:GetHeight())
AccBGS_KillsFrameIcon:SetPoint("left", AccBGS_KillsFrame, "left", 3, 0)
AccBGS_KillsFrameIcon:Show()

------------------------------------------------------------------------------------------------------------------------

local BGS_AchFrame = CreateFrame("frame", "BGS_AchFrame", BGStatFrame)
BGS_AchFrame.text = BGS_AchFrame:CreateFontString(nil, nil, "GameFontNormal")
BGS_AchFrame.text:SetPoint("left", 25, 0)
BGS_AchFrame:SetWidth(BGStatFrame:GetWidth())
BGS_AchFrame:SetHeight(20)
BGS_AchFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local BGS_AchFrameIcon = CreateFrame("frame", "BGS_AchFrameIcon", BGS_AchFrame)
function UpdateAchInfo()
   local HKills = GetAccHKills()
   local AchRankPath = [[]]
   local KillsLeft = 0
   if HKills < 1 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_01]]
      KillsLeft = 1 - HKills
   elseif 1 <= HKills and HKills < 100 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_02]]
      KillsLeft = 100 - HKills
   elseif 100 <= HKills and HKills < 500 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_03]]
      KillsLeft = 500 - HKills
   elseif 500 <= HKills and HKills < 1000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_04]]
      KillsLeft = 1000 - HKills
   elseif 1000 <= HKills and HKills < 5000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_06]]
      KillsLeft = 5000 - HKills
   elseif 5000 <= HKills and HKills < 10000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_09]]
      KillsLeft = 10000 - HKills
   elseif 10000 <= HKills and HKills < 25000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_11]]
      KillsLeft = 25000 - HKills
   elseif 25000 <= HKills and HKills < 50000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_14]]
      KillsLeft = 50000 - HKills
   elseif 50000 <= HKills and HKills < 100000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_15]]
      KillsLeft = 100000 - HKills
   elseif 100000 <= HKills and HKills < 250000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_16]]
      KillsLeft = 250000 - HKills
   elseif 250000 <= HKills then
      AchRankPath = [[Interface\ICONS\Achievement_BG_KillFlagCarriers_grabFlag_CapIt]]
      KillsLeft = "Max Rank"
   end
   BGS_AchFrameIcon:SetBackdrop({
         bgFile = AchRankPath,
         edgeFile = nill,
         tile = false,
         --tileSize = BGS_AchFrame:GetHeight() + 4 , edgeSize = BGS_AchFrame:GetHeight()  ,
         --insets = { left = 5, right = 4, top = 1 , bottom = 2 }
		 tileSize = 14  , edgeSize = 14  ,
         insets = { left = 0, right = 0, top = 0 , bottom = 0}
   })
   
   BGS_AchFrame.text:SetText(KillsLeft)
   
end
BGS_AchFrameIcon:SetWidth(BGS_AchFrame:GetHeight()-2)
BGS_AchFrameIcon:SetHeight(BGS_AchFrame:GetHeight()-2)
BGS_AchFrameIcon:SetPoint("left", BGS_AchFrame, "left", 4, -1)
BGS_AchFrameIcon:Show()
BGS_AchFrame:SetScript("OnShow", UpdateAchInfo)
BGS_AchFrame:Show()
BGS_AchFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

--[[
local HolidayFrame = CreateFrame("frame", "HolidayFrame", BGStatFrame)
HolidayFrame.text = HolidayFrame:CreateFontString(nil, nil, "GameFontNormal")
HolidayFrame.text:SetPoint("left", 25, 0)
HolidayFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, -25)
HolidayFrame:SetWidth(BGStatFrame:GetWidth())
HolidayFrame:SetHeight(20)
HolidayFrame:Hide()

local HolidayFrameIcon = CreateFrame("frame", "HolidayFrameIcon", HolidayFrame)
HolidayFrameIcon:SetWidth(HolidayFrame:GetHeight())
HolidayFrameIcon:SetHeight(HolidayFrame:GetHeight())
HolidayFrameIcon:SetPoint("left", HolidayFrame, "left", 0, 0)
HolidayFrameIcon:Show()
function UpdateHolidayInfo()
   OpenCalendar()
   
local TodayNr = date("%d") ;
----DEFAULT_CHAT:AddMessage(TodayNr)

local MonthNr = 0;
local IconPath = InterFace\ICONS\Spell_Shadow_Twilight;
local HolidayEvent = "No Holiday";
----DEFAULT_CHAT:AddMessage(TodayNr .. "  " .. MonthNr)
local CountedEvents = CalendarGetNumDayEvents(MonthNr, TodayNr);
----DEFAULT_CHAT:AddMessage(CountedEvents)
OpenCalendar()
CountedEvents = CalendarGetNumDayEvents(MonthNr, TodayNr);
----DEFAULT_CHAT:AddMessage(CountedEvents)
for i = 1, CountedEvents  do
----DEFAULT_CHAT:AddMessage("updating2")
   local name, description, texture = CalendarGetHolidayInfo(MonthNr, TodayNr, i);
   
   local StrFoundNr = string.find(name, "Call to ")
   if StrFoundNr ~= nil then 
      HolidayEvent = name
   end
end

------DEFAULT_CHAT:AddMessage("updating")
local ShortStr = string.replace(HolidayEvent, "Call to Arms: ", "")
------DEFAULT_CHAT:AddMessage(ShortStr)
if ShortStr == "Warsong Gulch" then
   ShortStr = "Warsong"
   IconPath = InterFace\ICONS\inv_misc_rune_07
elseif ShortStr == "Alterac Valley" then
   ShortStr = "Alterac"
   IconPath = InterFace\ICONS\inv_jewelry_necklace_21
elseif ShortStr == "Eye of the Storm" then
   ShortStr = "Eye o/t Storm"
   IconPath = InterFace\ICONS\spell_nature_eyeofthestorm
elseif ShortStr == "Strand of the Ancients" then
   ShortStr = "Strand"
   IconPath = InterFace\ICONS\achievement_bg_winsoa
elseif ShortStr == "Isle of Conquest" then
   ShortStr = "Conquest"
   IconPath = InterFace\ICONS\achievement_bg_winwsg
elseif ShortStr == "The Battle for Gilneas" then
   ShortStr = "Gilneas"
   IconPath = InterFace\ICONS\achievement_battleground_battleforgilneas
elseif ShortStr == "Twin Peaks" then
   ShortStr = "Twinn Peaks"
   IconPath = InterFace\ICONS\spell_nature_earthshock
elseif ShortStr == "Arathi Basin" then
   ShortStr = "Twinn Peaks"
   IconPath = InterFace\ICONS\inv_jewelry_amulet_07
end

HolidayFrame.text:SetText(ShortStr)

HolidayFrameIcon:SetBackdrop({
      bgFile =  IconPath,
      edgeFile = nill,
      tile = true,
      tileSize = HolidayFrame:GetHeight(), edgeSize = HolidayFrame:GetHeight(),
      insets = { left = 4, right = 0, top = 2 , bottom = 2 }
})

   
end
UpdateHolidayInfo()

]]--

------------------------------------------------------------------------------------------------------------------------

local BGScoreFrame = CreateFrame("frame", "BGScoreFrame", BGStatFrame)
BGScoreFrame.text = BGScoreFrame:CreateFontString(nil, nil, "GameFontNormal")
BGScoreFrame.text:SetPoint("left", 25, 0)
function UpdateBGScoreInfo()
   for i = 1, GetNumBattlefieldScores() do
      local name, killingBlows, honorableKills, deaths, honorGained, faction, race, class, classToken, damageDone, healingDone = GetBattlefieldScore(i)
      if name == GetUnitName("player", false) then
         BGScoreFrame.text:SetText("" .. honorableKills .. "(" .. killingBlows .. ") / " .. deaths)
      end
   end
end
UpdateBGScoreInfo()
BGScoreFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, 0)
BGScoreFrame:SetWidth(BGStatFrame:GetWidth())
BGScoreFrame:SetHeight(20)
BGScoreFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local BGScoreFrameIcon = CreateFrame("frame", "BGScoreFrameIcon", BGScoreFrame)
function BGScoreIcon()
   local EnglishFaction, localizedFaction = UnitFactionGroup("player")
   if EnglishFaction == "Horde" then
      BGScoreFrameIcon:SetBackdrop({
            bgFile = [[Interface\ICONS\Achievement_PVP_H_H]],
            edgeFile = nill,
            tile = false,
            tileSize = 14, edgeSize = 14,
            insets = { left = 0, right = 0, top = 0, bottom = 0 }
      })
   else
      BGScoreFrameIcon:SetBackdrop({
            bgFile = [[Interface\ICONS\Achievement_PVP_A_A]],
            edgeFile = nill,
            tile = false,
            tileSize = 14, edgeSize = 14,
            insets = { left = 0, right = 0, top = 0, bottom = 0 }
      })
   end
end
BGScoreIcon()
BGScoreFrameIcon:SetWidth(BGScoreFrame:GetHeight()-2)
BGScoreFrameIcon:SetHeight(BGScoreFrame:GetHeight()-2)
BGScoreFrameIcon:SetPoint("left", BGScoreFrame, "left", 4, -1)
BGScoreFrameIcon:Show()

------------------------------------------------------------------------------------------------------------------------
local BGS_TBFrame = CreateFrame("frame", "BGS_TBFrame", BGStatFrame)
BGS_TBFrame.text = BGS_TBFrame:CreateFontString(nil, nil, "GameFontNormal")
BGS_TBFrame.text:SetPoint("left", 25, 0)
function UpdateTBInfo()
   BGS_TBFrame.text:SetText(GetTB())
end
UpdateTBInfo()
BGS_TBFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, -25)
BGS_TBFrame:SetWidth(BGStatFrame:GetWidth())
BGS_TBFrame:SetHeight(20)
BGS_TBFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local BGS_TBFrameIcon = CreateFrame("frame", "BGS_TBFrameIcon", BGS_TBFrame)
BGS_TBFrameIcon:SetBackdrop({
      bgFile = [[Interface\ICONS\Achievement_Zone_Tolbarad]],
      edgeFile = nill,
      tile = false,
      tileSize = 14  , edgeSize = 14  ,
      insets = { left = 0, right = 0, top = 0, bottom = 0 }
})
BGS_TBFrameIcon:SetWidth(BGS_TBFrame:GetHeight()-2)
BGS_TBFrameIcon:SetHeight(BGS_TBFrame:GetHeight()-2)
BGS_TBFrameIcon:SetPoint("left", BGS_TBFrame, "left", 4, -1)
BGS_TBFrameIcon:Show()


----------------------------------------
-- Functions
----------------------------------------


function FrameHeights()
   local spacing = -25
   for  id, frame in ipairs(FrameTable) do
      local TempFrame = frame
      TempFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, spacing)
      spacing = spacing - TempFrame:GetHeight()
      TempFrame:Show()
   end
end

------------------------------------------------------------------------------------------------------------------------

function ResizeBG()
   local BGSize = 30
   for  id, frame in ipairs(FrameTable) do
      BGSize = BGSize + frame:GetHeight()
   end
   
   --[[ if BGS_HonorFrame:IsShown() then
      BGSize = BGSize + BGS_HonorFrame:GetHeight()
   end
   if BGS_ConquestFrame:IsShown() then
      BGSize = BGSize + BGS_ConquestFrame:GetHeight()
   end
   if BGS_KillsFrame:IsShown() then
      BGSize = BGSize + BGS_KillsFrame:GetHeight()
   end
   if BGS_AchFrame:IsShown() then
      BGSize = BGSize + BGS_AchFrame:GetHeight()
   end]]--
   BGStatFrame:SetHeight(BGSize)
   return true
end

ResizeBG()

------------------------------------------------------------------------------------------------------------------------

function TableRemoveFrame(FrameName2)
   for  id, frame in ipairs(FrameTable) do
      local TempFrameName = frame:GetName()
      if TempFrameName == FrameName2 then
         table.remove(FrameTable, id)
      end
   end
   
end

------------------------------------------------------------------------------------------------------------------------

function TableAddFrame(FrameName3)
   local FrameNotIn = true
   for  id, frame in ipairs(FrameTable) do -- All frames that are currently shown 
         local TempFrame = frame
         local TempFrameName = TempFrame:GetName()
         if TempFrameName == FrameName3 then
			FrameNotIn = true
		 end
   end
   if FrameNotIn then
   table.insert(FrameTable, table.getn(FrameTable) + 1, FrameName3)
   end
   
end


----------------------------------------
-- Options Frame
----------------------------------------


local BGS_OptionsFrame = CreateFrame("frame", "BGS_OptionsFrame", UIParent)
BGS_OptionsFrame:SetBackdrop({
      bgFile = [[Interface\DialogFrame\UI-DialogBox-Background-Dark]],
      edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]],
      tileSize = 16, edgeSize = 16,
      insets = { left = 3, right = 3, top = 5, bottom = 3 }
})
BGS_OptionsFrame:SetWidth(170)
BGS_OptionsFrame:SetHeight(190)
BGS_OptionsFrame:EnableMouse(true)
BGS_OptionsFrame:SetMovable(true)
BGS_OptionsFrame:SetPoint("Center", 0, 0)
BGS_OptionsFrame:RegisterForDrag("LeftButton")
BGS_OptionsFrame:SetScript("OnDragStart", BGS_OptionsFrame.StartMoving )
BGS_OptionsFrame:SetScript("OnDragStop", BGS_OptionsFrame.StopMovingOrSizing)
BGS_OptionsFrame:SetClampedToScreen(true)
BGS_OptionsFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local BGS_LockButton = CreateFrame("Button", "BGS_LockButton", BGS_OptionsFrame)
BGS_LockButton:SetWidth(16)
BGS_LockButton:SetHeight(16)
BGS_LockButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-BiggerButton-Up")
BGS_LockButton:SetHighlightTexture("Interface\\BUTTONS\\UI-Panel-BiggerButton-Down")
BGS_LockButton:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-BiggerButton-Down")
BGS_LockButton:SetPoint("topright", BGS_OptionsFrame, "topright", -17, -7)
BGS_LockButton:Show()
BGS_LockButton:SetScript("OnClick",  function() 
	if BGStatFrame:IsMouseEnabled() then
			BGStatFrame:EnableMouse(false)
			BGS_LockButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-BiggerButton-Disabled")
		else
			BGStatFrame:EnableMouse(true)
			BGS_LockButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-BiggerButton-Up")
		end
		MainFrameBG()
end)

------------------------------------------------------------------------------------------------------------------------

local BGS_CloseOptionButton = CreateFrame("Button", "BGS_CloseOptionButton", BGS_OptionsFrame)
BGS_CloseOptionButton:SetWidth(20)
BGS_CloseOptionButton:SetHeight(20)
BGS_CloseOptionButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Up")
BGS_CloseOptionButton:SetHighlightTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Highlight")
BGS_CloseOptionButton:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Down")
BGS_CloseOptionButton:SetPoint("topright", BGS_OptionsFrame, "topright", -1, -1)
BGS_CloseOptionButton:SetScript("OnClick",  function() BGS_OptionsFrame:Hide() end)

------------------------------------------------------------------------------------------------------------------------

local BGS_OptionTitle = CreateFrame("frame", "BGS_OptionTitle", BGS_OptionsFrame)
BGS_OptionTitle:SetWidth(80)
BGS_OptionTitle:SetHeight(20)
BGS_OptionTitle:SetPoint("top", BGS_OptionsFrame, "top", 0, -5)
BGS_OptionTitle.text = BGS_OptionTitle:CreateFontString(nil, nil, "QuestFont_Shadow_Small")
BGS_OptionTitle.text:SetPoint("center", 0, 0)
BGS_OptionTitle.text:SetText("BG Stats Options")

----------------------------------------
-- CheckButtons
----------------------------------------

local BGS_CBHonor = CreateFrame("checkbutton", "BGS_CBHonor", BGS_OptionsFrame)
BGS_CBHonor:SetWidth(20)
BGS_CBHonor:SetHeight(20)
BGS_CBHonor:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
BGS_CBHonor:SetHighlightTexture("Interface/BUTTONS/UI-CheckBox-Highlight")
BGS_CBHonor:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
BGS_CBHonor:SetPoint("topleft", BGS_OptionsFrame, "topleft", 15, -30)
BGS_CBHonor.text = BGS_CBHonor:CreateFontString(nil, nil, "GameFontNormal")
BGS_CBHonor.text:SetPoint("left", 25, 0)
BGS_CBHonor.text:SetText("Show Honor")
BGS_CBHonor:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
BGS_CBHonor:SetScript("OnClick", function ()
      if  BGS_HonorFrame:IsShown() then
         BGS_HonorFrame:Hide()
         BGS_CBHonor:SetChecked(false)
         TableRemoveFrame("BGS_HonorFrame")
      else
         BGS_HonorFrame:Show()
         BGS_CBHonor:SetChecked(true)
         TableAddFrame(BGS_HonorFrame)
      end
      FrameHeights()
      ResizeBG()
end)

------------------------------------------------------------------------------------------------------------------------

local BGS_CBConquest = CreateFrame("checkbutton", "BGS_CBConquest", BGS_OptionsFrame)
BGS_CBConquest:SetWidth(20)
BGS_CBConquest:SetHeight(20)
BGS_CBConquest:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
BGS_CBConquest:SetHighlightTexture("Interface/BUTTONS/UI-CheckBox-Highlight")
BGS_CBConquest:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
BGS_CBConquest:SetPoint("topleft", BGS_OptionsFrame, "topleft", 15, -50)
BGS_CBConquest.text = BGS_CBConquest:CreateFontString(nil, nil, "GameFontNormal")
BGS_CBConquest.text:SetPoint("left", 25, 0)
BGS_CBConquest.text:SetText("Show Conquest")
BGS_CBConquest:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
BGS_CBConquest:SetScript("OnClick", function ()
      if  BGS_ConquestFrame:IsShown() then
         BGS_ConquestFrame:Hide()
         BGS_CBConquest:SetChecked(false)
         TableRemoveFrame("BGS_ConquestFrame")
      else
         BGS_ConquestFrame:Show()
         BGS_CBConquest:SetChecked(true)
         TableAddFrame(BGS_ConquestFrame)
      end
      FrameHeights()
      ResizeBG()
end)

------------------------------------------------------------------------------------------------------------------------

local BGS_CBKills = CreateFrame("checkbutton", "BGS_CBKills", BGS_OptionsFrame)
BGS_CBKills:SetWidth(20)
BGS_CBKills:SetHeight(20)
BGS_CBKills:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
BGS_CBKills:SetHighlightTexture("Interface/BUTTONS/UI-CheckBox-Highlight")
BGS_CBKills:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
BGS_CBKills:SetPoint("topleft", BGS_OptionsFrame, "topleft", 15, -70)
BGS_CBKills.text = BGS_CBKills:CreateFontString(nil, nil, "GameFontNormal")
BGS_CBKills.text:SetPoint("left", 25, 0)
BGS_CBKills.text:SetText("Show Kills")
BGS_CBKills:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
BGS_CBKills:SetScript("OnClick", function ()
      if  BGS_KillsFrame:IsShown() then
         BGS_KillsFrame:Hide()
         BGS_CBKills:SetChecked(false)
         TableRemoveFrame("BGS_KillsFrame")
      else
         BGS_KillsFrame:Show()
         BGS_CBKills:SetChecked(true)
         TableAddFrame(BGS_KillsFrame)
      end
      FrameHeights()
      ResizeBG()
end)

local BGS_CBAccKills = CreateFrame("checkbutton", "BGS_CBAccKills", BGS_OptionsFrame)
BGS_CBAccKills:SetWidth(20)
BGS_CBAccKills:SetHeight(20)
BGS_CBAccKills:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
BGS_CBAccKills:SetHighlightTexture("Interface/BUTTONS/UI-CheckBox-Highlight")
BGS_CBAccKills:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
BGS_CBAccKills:SetPoint("topleft", BGS_OptionsFrame, "topleft", 15, -90)
BGS_CBAccKills.text = BGS_CBAccKills:CreateFontString(nil, nil, "GameFontNormal")
BGS_CBAccKills.text:SetPoint("left", 25, 0)
BGS_CBAccKills.text:SetText("Show Account Kills")
BGS_CBAccKills:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
BGS_CBAccKills:SetScript("OnClick", function ()
      if  AccBGS_KillsFrame:IsShown() then
         AccBGS_KillsFrame:Hide()
         BGS_CBAccKills:SetChecked(false)
         TableRemoveFrame("AccBGS_KillsFrame")
      else
         AccBGS_KillsFrame:Show()
         BGS_CBAccKills:SetChecked(true)
         TableAddFrame(AccBGS_KillsFrame)
      end
      FrameHeights()
      ResizeBG()
end)

------------------------------------------------------------------------------------------------------------------------

local BGS_CBAch = CreateFrame("checkbutton", "BGS_CBAch", BGS_OptionsFrame)
BGS_CBAch:SetWidth(20)
BGS_CBAch:SetHeight(20)
BGS_CBAch:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
BGS_CBAch:SetHighlightTexture("Interface/BUTTONS/UI-CheckBox-Highlight")
BGS_CBAch:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
BGS_CBAch:SetPoint("topleft", BGS_OptionsFrame, "topleft", 15, -110)
BGS_CBAch.text = BGS_CBAch:CreateFontString(nil, nil, "GameFontNormal")
BGS_CBAch.text:SetPoint("left", 25, 0)
BGS_CBAch.text:SetText("Show Achievement")
BGS_CBAch:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
BGS_CBAch:SetScript("OnClick", function ()
      if  BGS_AchFrame:IsShown() then
         BGS_AchFrame:Hide()
         BGS_CBAch:SetChecked(false)
         TableRemoveFrame("BGS_AchFrame")
      else
         BGS_AchFrame:Show()
         BGS_CBAch:SetChecked(true)
         TableAddFrame(BGS_AchFrame)
      end
      FrameHeights()
      ResizeBG()
end)

------------------------------------------------------------------------------------------------------------------------

--[[
local CBHoliday = CreateFrame("checkbutton", "CBHoliday", BGS_OptionsFrame)
CBHoliday:SetWidth(20)
CBHoliday:SetHeight(20)
CBHoliday:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")

CBHoliday:SetHighlightTexture("Interface\\BUTTONS\UI-CheckBox-Highlight")
CBHoliday:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
CBHoliday:SetPoint("topleft", BGS_OptionsFrame, "topleft", 15, -110)
CBHoliday.text = CBHoliday:CreateFontString(nil, nil, "GameFontNormal")
CBHoliday.text:SetPoint("left", 25, 0)
CBHoliday.text:SetText("Show Holiday")
CBHoliday:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
CBHoliday:SetScript("OnClick", function ()
      if  HolidayFrame:IsShown() then
         HolidayFrame:Hide()
         CBHoliday:SetChecked(false)
         TableRemoveFrame("HolidayFrame")
      else
         HolidayFrame:Show()
         CBHoliday:SetChecked(true)
         TableAddFrame(HolidayFrame)
      end
      FrameHeights()
      ResizeBG()
end)
]]--

------------------------------------------------------------------------------------------------------------------------

local BGS_CBBGScoreFrame = CreateFrame("checkbutton", "BGS_CBBGScoreFrame", BGS_OptionsFrame)
BGS_CBBGScoreFrame:SetWidth(20)
BGS_CBBGScoreFrame:SetHeight(20)
BGS_CBBGScoreFrame:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
BGS_CBBGScoreFrame:SetHighlightTexture("Interface/BUTTONS/UI-CheckBox-Highlight")
BGS_CBBGScoreFrame:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
BGS_CBBGScoreFrame:SetPoint("topleft", BGS_OptionsFrame, "topleft", 15, -130)
BGS_CBBGScoreFrame.text = BGS_CBBGScoreFrame:CreateFontString(nil, nil, "GameFontNormal")
BGS_CBBGScoreFrame.text:SetPoint("left", 25, 0)
BGS_CBBGScoreFrame.text:SetText("Show BG Stats")
BGS_CBBGScoreFrame:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
BGS_CBBGScoreFrame:SetScript("OnClick", function ()
      if  BGScoreFrame:IsShown() then
         BGScoreFrame:Hide()
         BGS_CBBGScoreFrame:SetChecked(false)
         TableRemoveFrame("BGScoreFrame")
      else
         BGScoreFrame:Show()
         BGS_CBBGScoreFrame:SetChecked(true)
         TableAddFrame(BGScoreFrame)
      end
      FrameHeights()
      ResizeBG()
end)

------------------------------------------------------------------------------------------------------------------------

local BGS_CBTolBarad = CreateFrame("checkbutton", "BGS_CBTolBarad", BGS_OptionsFrame)
BGS_CBTolBarad:SetWidth(20)
BGS_CBTolBarad:SetHeight(20)
BGS_CBTolBarad:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
BGS_CBTolBarad:SetHighlightTexture("Interface/BUTTONS/UI-CheckBox-Highlight")
BGS_CBTolBarad:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
BGS_CBTolBarad:SetPoint("topleft", BGS_OptionsFrame, "topleft", 15, -150)
BGS_CBTolBarad.text = BGS_CBTolBarad:CreateFontString(nil, nil, "GameFontNormal")
BGS_CBTolBarad.text:SetPoint("left", 25, 0)
BGS_CBTolBarad.text:SetText("Show Tol Barad")
BGS_CBTolBarad:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
BGS_CBTolBarad:SetScript("OnClick", function ()
      if  BGS_TBFrame:IsShown() then
         BGS_TBFrame:Hide()
         BGS_CBTolBarad:SetChecked(false)
         TableRemoveFrame("BGS_TBFrame")
      else
         BGS_TBFrame:Show()
         BGS_CBTolBarad:SetChecked(true)
         TableAddFrame(BGS_TBFrame)
      end
      FrameHeights()
      ResizeBG()
end)

----------------------------------------
-- Info Frame
----------------------------------------


local BGS_InfoFrame = CreateFrame("frame", "BGS_InfoFrame", UIParent)
BGS_InfoFrame:SetBackdrop({
      bgFile = [[Interface\DialogFrame\UI-DialogBox-Background-Dark]],
      edgeFile = nill,
      tileSize = 16, edgeSize = 16,
      insets = { left = 3, right = 3, top = 5, bottom = 3 }
})
BGS_InfoFrame:SetWidth(250)
BGS_InfoFrame:SetHeight(300)
BGS_InfoFrame:EnableMouse(true)
BGS_InfoFrame:SetMovable(true)
BGS_InfoFrame:SetPoint("Center", 0, 0)
BGS_InfoFrame:RegisterForDrag("LeftButton")
BGS_InfoFrame:SetScript("OnDragStart", BGS_InfoFrame.StartMoving )
BGS_InfoFrame:SetScript("OnDragStop", BGS_InfoFrame.StopMovingOrSizing)
BGS_InfoFrame.text = BGS_InfoFrame:CreateFontString(nil, nil, "QuestFont_Shadow_Small")
BGS_InfoFrame.text:SetPoint("top", 0, -10)
BGS_InfoFrame.text:SetText("BG Stats Information")
BGS_InfoFrame:SetClampedToScreen(true)
BGS_InfoFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local BGS_InfoText = CreateFrame("SimpleHTML", "BGS_InfoText", BGS_InfoFrame)
BGS_InfoText:SetWidth(BGS_InfoFrame:GetWidth()- 30)
BGS_InfoText:SetHeight(BGS_InfoFrame:GetHeight() - 30)
BGS_InfoText:SetPoint("topleft", BGS_InfoFrame, "Topleft", 15, -30)
BGS_InfoText:SetFont("Fonts\\FRIZQT__.TTF", 11)
BGS_InfoText:SetText('<html><body><p>|cffffcc00Author:|r LanceDH - Moonglade EU</p><p>|cffffcc00Version:|r '.. versionNr ..'</p><p>|cffffcc00Version Date:|r '.. versionDate ..'</p><br /><p>The frames will show up in the order you enable them.</p><p>|cffffcc00Honor:|r  Your honor points</p><p>|cffffcc00Conquest:|r Your conquest points</p><p>|cffffcc00Kills:|r Your character specific honorable kills</p><p>|cffffcc00Account Kills:|r Your account wide honorable kills (up to 250k)</p><p>|cffffcc00Achievement:|r Amount of kills needed until next account wide achievement</p><p>|cffffcc00BG Stats:|r Your stats in the current battleground.</p><p align="right">|cffffcc00Honorable Kills|r(|cffffcc00Killing Blows|r)/|cffffcc00Deaths|r</p><p>|cffffcc00Tol Barad:|r  Your Tol Barad Commendations</p><p> </p><p>You can lock the tracking frame by using the |cffffcc00arrow button|r in the options menu or typing |cffffcc00/bgstats lock|r</p></body></html>')

------------------------------------------------------------------------------------------------------------------------

local BGS_CloseInfo = CreateFrame("Button", "BGS_CloseInfo", BGS_InfoFrame)
BGS_CloseInfo:SetWidth(16)
BGS_CloseInfo:SetHeight(16)
BGS_CloseInfo:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Up")
BGS_CloseInfo:SetHighlightTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Highlight")
BGS_CloseInfo:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Down")
BGS_CloseInfo:SetPoint("topright", BGS_InfoFrame, "topright", 0, -2)
BGS_CloseInfo:Show()
BGS_CloseInfo:SetScript("OnClick",  function() BGS_InfoFrame:Hide() end)

------------------------------------------------------------------------------------------------------------------------

local BGS_InfoButton = CreateFrame("Button", "BGS_InfoButton", BGS_OptionsFrame)
BGS_InfoButton:SetWidth(14)
BGS_InfoButton:SetHeight(14)
BGS_InfoButton:SetNormalTexture("Interface\\FriendsFrame\\InformationIcon")
BGS_InfoButton:SetHighlightTexture("Interface\\FriendsFrame\\InformationIcon-Highlight")
BGS_InfoButton:SetPoint("bottomright", BGS_OptionsFrame, "bottomright", -5, 5)
BGS_InfoButton:Show()
BGS_InfoButton:SetScript("OnClick",  function() BGS_InfoFrame:Show() end)
BGS_InfoButton:SetAlpha(0.5)


----------------------------------------
-- Updates
----------------------------------------

function KillInfos()
   UpdateKillsInfo()
   UpdateAchInfo()
   UpdateAccKillsInfo()
end

------------------------------------------------------------------------------------------------------------------------

function CurrInfos()
   UpdateConquestInfo()
   UpdateHonorInfo()
   UpdateTBInfo()
end

----------------------------------------
-- Event Frames
----------------------------------------

local BGS_KillEventFrame = CreateFrame("FRAME", "BGS_KillEventFrame");
BGS_KillEventFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
BGS_KillEventFrame:SetScript("OnEvent", KillInfos);

------------------------------------------------------------------------------------------------------------------------

local BGS_ConquestEventFrame = CreateFrame("FRAME", "BGS_ConquestEventFrame");
BGS_ConquestEventFrame:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
BGS_ConquestEventFrame:SetScript("OnEvent", CurrInfos);

------------------------------------------------------------------------------------------------------------------------

local BGS_ZoneEventFrame = CreateFrame("FRAME", "BGS_ZoneEventFrame");
BGS_ZoneEventFrame:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND");
BGS_ZoneEventFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
BGS_ZoneEventFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
BGS_ZoneEventFrame:RegisterEvent("UPDATE_BATTLEFIELD_SCORE");
BGS_ZoneEventFrame:RegisterEvent("PLAYER_DEAD");
function BGS_ZoneEventFrame:OnEvent(event)
	--DEFAULT_CHAT_FRAME:AddMessage(event)
   if event == "PLAYER_ENTERING_BATTLEGROUND" or event == "PLAYER_PVP_KILLS_CHANGED" or event == "UPDATE_BATTLEFIELD_SCORE" or event == "PLAYER_DEAD" then
      BGScoreFrame.text:SetText("Updating...")
	  local isInstance, instanceType = IsInInstance()
	  if instanceType == "pvp" then
		RequestBattlefieldScoreData()
		UpdateBGScoreInfo()
	  else
	    BGScoreFrame.text:SetText("Not in a BG")
	  end
   elseif event == "PLAYER_ENTERING_WORLD" then
      BGScoreFrame.text:SetText("Not in a BG")
   end
end
BGS_ZoneEventFrame:SetScript("OnEvent", BGS_ZoneEventFrame.OnEvent);

------------------------------------------------------------------------------------------------------------------------

local BGS_LoadedFrame = CreateFrame("FRAME", "BGS_LoadedFrame"); 
BGS_LoadedFrame:RegisterEvent("ADDON_LOADED");
BGS_LoadedFrame:RegisterEvent("PLAYER_LOGOUT");
function BGS_LoadedFrame:OnEvent(event)
   if event == "ADDON_LOADED" then
   while runCount ~= 1 do	--
   
      if firstRun == false then --not first Time running 
			
            local HonorIn = true
            local ConquestIn = true
            local KillsIn = true
			local accKillsIn = true
            local AchIn = true
            local BGIn = true
			local TBIn = true
			
			TableRemoveFrame(BGS_HonorFrame)
            TableRemoveFrame(BGS_ConquestFrame)
            TableRemoveFrame(BGS_KillsFrame)
			TableRemoveFrame(AccBGS_KillsFrame)
            TableRemoveFrame(BGS_AchFrame)
				--TableAddFrame(HolidayFrame)
            TableRemoveFrame(BGScoreFrame)
			TableRemoveFrame(BGS_TBFrame)
			-- Check every option
            BGS_CBHonor:SetChecked(false)
            BGS_CBConquest:SetChecked(false)
            BGS_CBKills:SetChecked(false)
			BGS_CBAccKills:SetChecked(false)
            BGS_CBAch:SetChecked(false)
            BGS_CBBGScoreFrame:SetChecked(false)
			BGS_CBTolBarad:SetChecked(false)
			
            for  id, frame in ipairs(ShownFramesTable)  do -- Check which frames are saved, and load them
               local FrameName = frame
               if FrameName == "BGS_HonorFrame" and HonorIn then
                  HonorIn = false
                  TableAddFrame(BGS_HonorFrame)
                  BGS_HonorFrame:Show()
                  BGS_CBHonor:SetChecked(true)
               elseif FrameName == "BGS_ConquestFrame" and ConquestIn then
                  ConquestIn = false
                  TableAddFrame(BGS_ConquestFrame)
                  BGS_ConquestFrame:Show()
                  BGS_CBConquest:SetChecked(true)
               elseif FrameName == "BGS_KillsFrame" and KillsIn then
                  KillsIn = false
                  TableAddFrame(BGS_KillsFrame)
                  BGS_KillsFrame:Show()
                  BGS_CBKills:SetChecked(true)
			   elseif FrameName == "AccBGS_KillsFrame" and accKillsIn then
                  accKillsIn = false
                  TableAddFrame(AccBGS_KillsFrame)
                  AccBGS_KillsFrame:Show()
                  BGS_CBAccKills:SetChecked(true)
               elseif FrameName == "BGS_AchFrame" and AchIn then
                  AchIn = false
                  TableAddFrame(BGS_AchFrame)
                  BGS_AchFrame:Show()
                  BGS_CBAch:SetChecked(true)
                  --elseif FrameName == "HolidayFrame" then
                  --  TableAddFrame(HolidayFrame)
                  --  HolidayFrame:Show()
                  -- CBHoliday:SetChecked(true)
               elseif FrameName == "BGScoreFrame" and BGIn then
                  BGIn = false
                  TableAddFrame(BGScoreFrame)
                  BGScoreFrame:Show()
                  BGS_CBBGScoreFrame:SetChecked(true)
				elseif FrameName == "BGS_TBFrame" and TBIn then
					TBIn = false
					TableAddFrame(BGS_TBFrame)
					BGS_TBFrame:Show()
					BGS_CBTolBarad:SetChecked(true)
               end
             end
			
		
			
		
         
         
         ResizeBG()
         FrameHeights()
         
         CurrInfos()
         
      MainFrameBG()
      if IsShown == false then
         BGStatFrame:Hide()
      else
         BGStatFrame:Show()
      end

	if CanMove == false then
			BGStatFrame:EnableMouse(false)
			BGS_LockButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-BiggerButton-Disabled")
			BGStatFrame:SetBackdrop({
				bgFile = [[Interface\COMMON\ShadowOverlay-Right]],
				edgeFile = nill,
				tileSize = 16, edgeSize = 16,
				insets = { left = 3, right = 3, top = 5, bottom = 3 }
			})
		else
			BGStatFrame:EnableMouse(true)
			BGS_LockButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-BiggerButton-Up")
			BGStatFrame:SetBackdrop({
				bgFile = [[Interface\COMMON\ShadowOverlay-Right]],
				edgeFile = [[Interface/DialogFrame/UI-DialogBox-Border]],
				tileSize = 16, edgeSize = 16,
				insets = { left = 3, right = 3, top = 5, bottom = 3 }
			})
		end
	  
      KillInfos()
	  else
			-- Add every frame
			TableAddFrame(BGS_HonorFrame)
            TableAddFrame(BGS_ConquestFrame)
            TableAddFrame(BGS_KillsFrame)
			TableAddFrame(AccBGS_KillsFrame)
            TableAddFrame(BGS_AchFrame)
				--TableAddFrame(HolidayFrame)
            TableAddFrame(BGScoreFrame)
			TableAddFrame(BGS_TBFrame)
			-- Check every option
            BGS_CBHonor:SetChecked(true)
            BGS_CBConquest:SetChecked(true)
            BGS_CBKills:SetChecked(true)
			BGS_CBAccKills:SetChecked(true)
            BGS_CBAch:SetChecked(true)
            BGS_CBBGScoreFrame:SetChecked(true)
			BGS_CBTolBarad:SetChecked(true)
			BGS_HonorFrame:Show()
			BGS_ConquestFrame:Show()
			BGS_KillsFrame:Show()
			AccBGS_KillsFrame:Show()
			BGS_AchFrame:Show()
			BGScoreFrame:Show()
			BGS_TBFrame:Show()
			
			-- Movable
			BGStatFrame:EnableMouse(true)
			BGS_LockButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-BiggerButton-Up")
			BGStatFrame:SetBackdrop({
				bgFile = [[Interface\COMMON\ShadowOverlay-Right]],
				edgeFile = [[Interface/DialogFrame/UI-DialogBox-Border]],
				tileSize = 16, edgeSize = 16,
				insets = { left = 3, right = 3, top = 5, bottom = 3 }
			})
    end
      -- UpdateHolidayInfo()
    runCount = runCount + 1 
	end
	CurrInfos()
	KillInfos()
	ResizeBG()
    FrameHeights()
         
      ------------------------------------------------------------------------------------------------------------------------
   elseif event == "PLAYER_LOGOUT" then
      
      ShownFramesTable = {}
      for  id, frame in ipairs(FrameTable) do -- All frames that are currently shown 
         local TempFrame = frame
         local TempFrameName = TempFrame:GetName()
         table.insert(ShownFramesTable, table.getn(ShownFramesTable) + 1, TempFrameName) -- Save framename
      end
      runCount = 1
      
      if BGStatFrame:IsShown() then
         IsShown = true
      else
         IsShown = false
      end
	  
	  if BGStatFrame:IsMouseEnabled() then
		CanMove = true
	  else
		CanMove = false
	  end
      firstRun = false
   end
end
BGS_LoadedFrame:SetScript("OnEvent", BGS_LoadedFrame.OnEvent)

----------------------------------------
-- Slash Commands
----------------------------------------

SLASH_PVPSTATS1 = '/bgstats';
local function slashcmd(msg, editbox)
	if msg == '' then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFAA00BGstats commands:|r")
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFAA00/bgstats show|r: Shows the tracking frame when hidden.")
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFAA00/bgstats options|r: Shows the options menu.")
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFAA00/bgstats lock|r: Toggle moveable tracking frame .")
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFAA00/bgstats info|r: Show a frame with some information of the addon.")
		elseif msg == 'show' then
      BGStatFrame:Show()
      IsShown = true
   elseif msg == 'options' then
      BGS_OptionsFrame:Show()
   elseif msg == 'info' then
      BGS_InfoFrame:Show()  
	elseif msg == 'lock' then
		if BGStatFrame:IsMouseEnabled() then
			BGStatFrame:EnableMouse(false)
			BGS_LockButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-BiggerButton-Disabled")
		else
			BGStatFrame:EnableMouse(true)
			BGS_LockButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-BiggerButton-Up")
		end
		MainFrameBG()
		
	-- Debug
    
   elseif msg == 'resize' then
   if debugMode then
      if ResizeBG() == true then
	  DEFAULT_CHAT_FRAME:AddMessage("|cFFFFAA00resized|r")
	  end
	end
	elseif msg == 'print' then
	 if debugMode then
      for  id, frame in ipairs(FrameTable) do -- All frames that are currently shown 
         local TempFrame = frame
         local TempFrameName = TempFrame:GetName()
         DEFAULT_CHAT_FRAME:AddMessage("".. TempFrameName)
	  end   
	end
	  
   end
end
SlashCmdList["PVPSTATS"] = slashcmd

